liebherr = {}

function liebherr.prerequisitesPresent(specializations)
     Vehicle.registerJointType("shovel");
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function liebherr:load(xmlFile)
 self.frontlight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.frontlight#index"));
    setVisibility(self.frontlight, false);

 self.braslight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.braslight#index"));
    setVisibility(self.braslight, false);

 self.backlight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.backlight#index"));
    setVisibility(self.backlight, false); 

 self.codelight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.codelight#index"));
    setVisibility(self.codelight, false);
   

     local hidraulicSound = getXMLString(xmlFile, "vehicle.hidraulicSound#file");
    if hidraulicSound ~= nil and hidraulicSound ~= "" then
        hidraulicSound = Utils.getFilename(hidraulicSound, self.baseDirectory); 
        self.hidraulicSound = createSample("hidraulicSound");
        loadSample(self.hidraulicSound, hidraulicSound, false);
        self.hidraulicSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hidraulicSound#pitchOffset"), 1);
        self.hidraulicSoundPitchScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hidraulicSound#pitchScale"), 0);
        self.hidraulicSoundPitchMax = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hidraulicSound#pitchMax"), 2.0);
    end;
   
 
    
    local workingArmNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.workingArm#index"));
    if workingArmNode ~= nil then
        self.workingArm = {};
        self.workingArm.node = workingArmNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.workingArm#minRot"));
        self.workingArm.minRot = {};
        self.workingArm.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.workingArm.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.workingArm.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.workingArm#maxRot"));
        self.workingArm.maxRot = {};
        self.workingArm.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.workingArm.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.workingArm.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

		self.workingArm.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.workingArm#rotTime"), 2)*1000;


		self.workingArm.fixPoint = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.workingArm#fixPoint"));
    end;
    
    local transformer1Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.transformer#index"));
    if transformer1Node ~= nil then
        self.transformer = {};
        self.transformer.node = transformer1Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.transformer#minRot"));
        self.transformer.minRot = {};
        self.transformer.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.transformer.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.transformer.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.transformer#maxRot"));
        self.transformer.maxRot = {};
        self.transformer.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.transformer.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.transformer.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));


		self.transformer.rotTime = self.workingArm.rotTime;


		self.transformer.fixPoint = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.transformer#fixPoint"));

		self.transformer.transform2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.transformer#index2"));
    end;

   
  

   
    
    local rotationPartNodetourelle = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tourelle#index"));
    if rotationPartNodetourelle ~= nil then
        self.tourelle = {};
        self.tourelle.node = rotationPartNodetourelle;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tourelle#minRot"));
        self.tourelle.minRot = {};
        self.tourelle.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.tourelle.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.tourelle.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tourelle#maxRot"));
        self.tourelle.maxRot = {};
        self.tourelle.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.tourelle.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.tourelle.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.tourelle.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.tourelle#rotTime"), 2)*1000;
        self.tourelle.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.tourelle#touchRotLimit"), 10))
    end;
    local rotationPartNodeflex1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex1#index"));
    if rotationPartNodeflex1 ~= nil then
        self.flex1 = {};
        self.flex1.node = rotationPartNodeflex1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex1#minRot"));
        self.flex1.minRot = {};
        self.flex1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex1#maxRot"));
        self.flex1.maxRot = {};
        self.flex1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.flex1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex1#rotTime"), 2)*1000;
        self.flex1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex1#touchRotLimit"), 10))
    end;
    local rotationPartNodeflex2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex2#index"));
    if rotationPartNodeflex2 ~= nil then
        self.flex2 = {};
        self.flex2.node = rotationPartNodeflex2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex2#minRot"));
        self.flex2.minRot = {};
        self.flex2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex2#maxRot"));
        self.flex2.maxRot = {};
        self.flex2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.flex2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex2#rotTime"), 2)*1000;
        self.flex2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex2#touchRotLimit"), 10))
    end;
     local rotationPartNodeflex3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex3#index"));
    if rotationPartNodeflex3 ~= nil then
        self.flex3 = {};
        self.flex3.node = rotationPartNodeflex3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex3#minRot"));
        self.flex3.minRot = {};
        self.flex3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex3#maxRot"));
        self.flex3.maxRot = {};
        self.flex3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.flex3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex3#rotTime"), 2)*1000;
        self.flex3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex3#touchRotLimit"), 10))
    end;
    local rotationPartNodeflex4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex4#index"));
    if rotationPartNodeflex4 ~= nil then
        self.flex4 = {};
        self.flex4.node = rotationPartNodeflex4;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex4#minRot"));
        self.flex4.minRot = {};
        self.flex4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex4#maxRot"));
        self.flex4.maxRot = {};
        self.flex4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.flex4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex4#rotTime"), 2)*1000;
        self.flex4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex4#touchRotLimit"), 10))
    end;
    local rotationPartNodeflex6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex6#index"));
    if rotationPartNodeflex6 ~= nil then
        self.flex6 = {};
        self.flex6.node = rotationPartNodeflex6;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex6#minRot"));
        self.flex6.minRot = {};
        self.flex6.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex6.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex6.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex6#maxRot"));
        self.flex6.maxRot = {};
        self.flex6.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex6.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex6.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.flex6.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex6#rotTime"), 2)*1000;
        self.flex6.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex6#touchRotLimit"), 10))
    end;
    local rotationPartNodeflex7 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex7#index"));
    if rotationPartNodeflex7 ~= nil then
        self.flex7 = {};
        self.flex7.node = rotationPartNodeflex7;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex7#minRot"));
        self.flex7.minRot = {};
        self.flex7.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex7.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex7.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex7#maxRot"));
        self.flex7.maxRot = {};
        self.flex7.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex7.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex7.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.flex7.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex7#rotTime"), 2)*1000;
        self.flex7.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex7#touchRotLimit"), 10))
    end;
    
    local rotationPartNodeflex12 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex12#index"));
    if rotationPartNodeflex12 ~= nil then
        self.flex12 = {};
        self.flex12.node = rotationPartNodeflex12;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex12#minRot"));
        self.flex12.minRot = {};
        self.flex12.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex12.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex12.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex12#maxRot"));
        self.flex12.maxRot = {};
        self.flex12.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex12.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex12.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.flex12.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex12#rotTime"), 2)*1000;
        self.flex12.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex12#touchRotLimit"), 10))
    end;
    local rotationPartNodeflex13 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex13#index"));
    if rotationPartNodeflex13 ~= nil then
        self.flex13 = {};
        self.flex13.node = rotationPartNodeflex13;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex13#minRot"));
        self.flex13.minRot = {};
        self.flex13.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex13.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex13.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex13#maxRot"));
        self.flex13.maxRot = {};
        self.flex13.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex13.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex13.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.flex13.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex13#rotTime"), 2)*1000;
        self.flex13.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex13#touchRotLimit"), 10))
    end;
                        local rotationPartNodeflex14 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex14#index"));
    if rotationPartNodeflex14 ~= nil then
        self.flex14 = {};
        self.flex14.node = rotationPartNodeflex14;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex14#minRot"));
        self.flex14.minRot = {};
        self.flex14.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex14.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex14.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex14#maxRot"));
        self.flex14.maxRot = {};
        self.flex14.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex14.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex14.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.flex14.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex14#rotTime"), 2)*1000;
        self.flex14.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex14#touchRotLimit"), 10))
    end;
                        local rotationPartNodeflex15 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex15#index"));
    if rotationPartNodeflex15 ~= nil then
        self.flex15 = {};
        self.flex15.node = rotationPartNodeflex15;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex15#minRot"));
        self.flex15.minRot = {};
        self.flex15.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex15.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex15.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.flex15#maxRot"));
        self.flex15.maxRot = {};
        self.flex15.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.flex15.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.flex15.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.flex15.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex15#rotTime"), 2)*1000;
        self.flex15.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.flex15#touchRotLimit"), 10))
    end;
    
    local rotationPartNodebras2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras2#index"));
    if rotationPartNodebras2 ~= nil then
        self.bras2 = {};
        self.bras2.node = rotationPartNodebras2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.bras2#minRot"));
        self.bras2.minRot = {};
        self.bras2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.bras2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.bras2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.bras2#maxRot"));
        self.bras2.maxRot = {};
        self.bras2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.bras2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.bras2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.bras2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.bras2#rotTime"), 2)*1000;
     
     
	    self.bras2.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras2#pivotverin"));
	    self.bras2.pivotverin2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras2#pivotverin2"));
	    self.bras2.pivotverin3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras2#pivotverin3"));
    end;
        local rotationPartNodebras3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras3#index"));
    if rotationPartNodebras3 ~= nil then
        self.bras3 = {};
        self.bras3.node = rotationPartNodebras3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.bras3#minRot"));
        self.bras3.minRot = {};
        self.bras3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.bras3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.bras3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.bras3#maxRot"));
        self.bras3.maxRot = {};
        self.bras3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.bras3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.bras3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.bras3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.bras3#rotTime"), 2)*1000;


	    self.bras3.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras3#pivotverin"));
	    self.bras3.pivotverin2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras3#pivotverin2"));
    end;

 
    local rotationPartNodebras1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras1#index"));
    if rotationPartNodebras1 ~= nil then
        self.bras1 = {};
        self.bras1.node = rotationPartNodebras1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.bras1#minRot"));
        self.bras1.minRot = {};
        self.bras1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.bras1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.bras1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.bras1#maxRot"));
        self.bras1.maxRot = {};
        self.bras1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.bras1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.bras1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.bras1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.bras1#rotTime"), 2)*1000;
     
     
	    self.bras1.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras1#pivotverin"));
	    self.bras1.pivotverin2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras1#pivotverin2"));
    end;
    
        local rotationPartNodebras4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras4#index"));
    if rotationPartNodebras4 ~= nil then
        self.bras4 = {};
        self.bras4.node = rotationPartNodebras4;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.bras4#minRot"));
        self.bras4.minRot = {};
        self.bras4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.bras4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.bras4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.bras4#maxRot"));
        self.bras4.maxRot = {};
        self.bras4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.bras4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.bras4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.bras4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.bras4#rotTime"), 2)*1000;


	    self.bras4.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras4#pivotverin"));
    end;
    
   
	
    self.verin2 = {};
	self.verin2.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin2#indexverin"));
	self.verin2.tige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin2#indextige"));
	self.verin2.translationtige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin2#translationtige"));
	local ax, ay, az = getWorldTranslation(self.verin2.tige);
    local bx, by, bz = getWorldTranslation(self.verin2.translationtige);
    self.verin2.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
    
        self.verin3 = {};
	self.verin3.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin3#indexverin"));
	self.verin3.tige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin3#indextige"));
	self.verin3.translationtige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin3#translationtige"));
	local ax, ay, az = getWorldTranslation(self.verin3.tige);
    local bx, by, bz = getWorldTranslation(self.verin3.translationtige);
    self.verin3.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);

    self.verin1 = {};
	self.verin1.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin1#indexverin"));
	self.verin1.tige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin1#indextige"));
	self.verin1.translationtige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin1#translationtige"));
	local ax, ay, az = getWorldTranslation(self.verin1.tige);
    local bx, by, bz = getWorldTranslation(self.verin1.translationtige);
    self.verin1.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
    
    self.flex5 = {};
	self.flex5.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex5#indexverin"));
	self.flex5.tige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex5#indextige"));
	self.flex5.translationtige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex5#translationtige"));
	local ax, ay, az = getWorldTranslation(self.flex5.tige);
    local bx, by, bz = getWorldTranslation(self.flex5.translationtige);
    self.flex5.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);

	    self.flex8 = {};
	self.flex8.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex8#indexverin"));
	self.flex8.tige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex8#indextige"));
	self.flex8.translationtige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex8#translationtige"));
	local ax, ay, az = getWorldTranslation(self.flex8.tige);
    local bx, by, bz = getWorldTranslation(self.flex8.translationtige);
    self.flex8.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
    
    	    self.flex9= {};
	self.flex9.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex9#indexverin"));
	self.flex9.tige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex9#indextige"));
	self.flex9.translationtige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex9#translationtige"));
	local ax, ay, az = getWorldTranslation(self.flex9.tige);
    local bx, by, bz = getWorldTranslation(self.flex9.translationtige);
    self.flex9.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);

    	    self.flex10 = {};
	self.flex10.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex10#indexverin"));
	self.flex10.tige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex10#indextige"));
	self.flex10.translationtige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex10#translationtige"));
	local ax, ay, az = getWorldTranslation(self.flex10.tige);
    local bx, by, bz = getWorldTranslation(self.flex10.translationtige);
    self.flex10.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
        	    self.flex11 = {};
	self.flex11.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex11#indexverin"));
	self.flex11.tige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex11#indextige"));
	self.flex11.translationtige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.flex11#translationtige"));
	local ax, ay, az = getWorldTranslation(self.flex11.tige);
    local bx, by, bz = getWorldTranslation(self.flex11.translationtige);
    self.flex11.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);



    
  
    
    self.hydraulicMainArm = {};
	self.hydraulicMainArm.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hydraulicMainArm#indexHydraulic"));
	self.hydraulicMainArm.punch = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hydraulicMainArm#indexPunch"));
	self.hydraulicMainArm.translationPunch = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hydraulicMainArm#translationPunch"));
	local ax, ay, az = getWorldTranslation(self.hydraulicMainArm.punch);
    local bx, by, bz = getWorldTranslation(self.hydraulicMainArm.translationPunch);
    self.hydraulicMainArm.punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
    
    

    
    
	local objectAttacher = {};
	objectAttacher.joint = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.anchor#index"));
	objectAttacher.index = 0;
	self.object = objectAttacher;
	self.attachedObject = nil;
	self.objectAttachable = false;
	self.objectInRange = nil;
	
    

    
	
    self.fillScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fillScale#value"), 1);
	self.name = Utils.getNoNil(getXMLString(xmlFile, "vehicle.name."..g_languageShort), "Objekt");
	
	
	
        self.frontlightActive = false;
        self.braslightActive = false;
        self.backlightActive = false;   
        self.codelightActive = false;   
	
end;

function liebherr:delete()
   if self.hidraulicSound ~= nil then
        delete(self.hidraulicSound);
    end;
end;

function liebherr:readStream(streamId, connection)
      if self.workingArmNode ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.workingArmNode.node, x, y, z);
      end;
     if self.transformer ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.transformer.node, x, y, z);
      end;

    if self.tourelle ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.tourelle.node, x, y, z);
      end;
          if self.flex1 ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.flex1.node, x, y, z);
      end;
                if self.flex2 ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.flex2.node, x, y, z);
      end;
                if self.flex3 ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.flex3.node, x, y, z);
      end;
                if self.flex4 ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.flex4.node, x, y, z);
      end;
                      if self.flex6 ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.flex6.node, x, y, z);
      end;
                       if self.flex7 ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.flex7.node, x, y, z);
      end;
                             if self.flex12 ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.flex12.node, x, y, z);
      end;
                             if self.flex13 ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.flex13.node, x, y, z);
      end;
                             if self.flex14 ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.flex14.node, x, y, z);
      end;
                             if self.flex15 ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.flex15.node, x, y, z);
      end;

   if self.bras2 ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.bras2.node, x, y, z);
      end;
    if self.bras3 ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.bras3.node, x, y, z);
      end;
   if self.bras1 ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.bras1.node, x, y, z);
      end;
         if self.bras4 ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.bras4.node, x, y, z);
      end;

end;
  
function liebherr:writeStream(streamId, connection)
     
     if self.workingArmNode ~= nil then
          local x, y, z = getRotation(self.workingArmNode.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
      if self.transformer ~= nil then
          local x, y, z = getRotation(self.transformer.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
      if self.tourelle ~= nil then
          local x, y, z = getRotation(self.tourelle.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
            if self.flex1 ~= nil then
          local x, y, z = getRotation(self.flex1.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
                  if self.flex2 ~= nil then
          local x, y, z = getRotation(self.flex2.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
                  if self.flex3 ~= nil then
          local x, y, z = getRotation(self.flex3.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
                  if self.flex4 ~= nil then
          local x, y, z = getRotation(self.flex4.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
                        if self.flex6 ~= nil then
          local x, y, z = getRotation(self.flex6.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
                        if self.flex7 ~= nil then
          local x, y, z = getRotation(self.flex7.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
                              if self.flex12 ~= nil then
          local x, y, z = getRotation(self.flex12.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
                              if self.flex13 ~= nil then
          local x, y, z = getRotation(self.flex13.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
                              if self.flex14 ~= nil then
          local x, y, z = getRotation(self.flex14.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
                              if self.flex15 ~= nil then
          local x, y, z = getRotation(self.flex15.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
      if self.bras2 ~= nil then
          local x, y, z = getRotation(self.bras2.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
            if self.bras3 ~= nil then
          local x, y, z = getRotation(self.bras3.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
      if self.bras1 ~= nil then
          local x, y, z = getRotation(self.bras1.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
            if self.bras4 ~= nil then
          local x, y, z = getRotation(self.bras4.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;

end;



function liebherr:mouseEvent(posX, posY, isDown, isUp, button)
end;

function liebherr:keyEvent(unicode, sym, modifier, isDown)    

	if self.isEntered and self.isMotorStarted then
	if sym == Input.KEY_KP_7 then
		self.rotationMinbras2 = isDown;
                self.playHidraulic = not self.playHidraulic;            
       end;
	
	if sym == Input.KEY_KP_4 then
		self.rotationMaxbras2 = isDown;
                self.playHidraulic1 = not self.playHidraulic1;
	 end;
	 	 	if sym == Input.KEY_KP_0 then
		self.rotationMaxbras3 = isDown;
                self.playHidraulic = not self.playHidraulic;
       end;
       	if sym == Input.KEY_KP_3 then
		self.rotationMinbras3 = isDown;
                self.playHidraulic = not self.playHidraulic;
       end;
	if sym == Input.KEY_KP_8 then
		self.rotationMinbras1 = isDown;
                self.playHidraulic2 = not self.playHidraulic2;	 
         end;
	if sym == Input.KEY_KP_5 then
		self.rotationMaxbras1 = isDown;
	 self.playHidraulic3 = not self.playHidraulic3;
        end;
	if sym == Input.KEY_KP_2 then
		self.rotationMintourelle = isDown;
	self.playHidraulic4 = not self.playHidraulic4;
         end;
	if sym == Input.KEY_KP_1 then
		self.rotationMaxtourelle = isDown;
	self.playHidraulic5 = not self.playHidraulic5;
        end;
    if sym == Input.KEY_KP_7 then
		self.rotationMinflex1 = isDown;
	self.playHidraulic4 = not self.playHidraulic4;
         end;
	if sym == Input.KEY_KP_4 then
		self.rotationMaxflex1 = isDown;
	self.playHidraulic5 = not self.playHidraulic5;
        end;
            if sym == Input.KEY_KP_7 then
		self.rotationMinflex2 = isDown;
	self.playHidraulic4 = not self.playHidraulic4;
         end;
	if sym == Input.KEY_KP_4 then
		self.rotationMaxflex2 = isDown;
	self.playHidraulic5 = not self.playHidraulic5;
        end;
            if sym == Input.KEY_KP_7 then
		self.rotationMinflex3 = isDown;
	self.playHidraulic4 = not self.playHidraulic4;
         end;
	if sym == Input.KEY_KP_4 then
		self.rotationMaxflex3 = isDown;
	self.playHidraulic5 = not self.playHidraulic5;
        end;
            if sym == Input.KEY_KP_7 then
		self.rotationMinflex4 = isDown;
	self.playHidraulic4 = not self.playHidraulic4;
         end;
	if sym == Input.KEY_KP_4 then
		self.rotationMaxflex4 = isDown;
	self.playHidraulic5 = not self.playHidraulic5;
        end;
                    if sym == Input.KEY_KP_3 then
		self.rotationMinflex6 = isDown;
	self.playHidraulic4 = not self.playHidraulic4;
         end;
	if sym == Input.KEY_KP_0 then
		self.rotationMaxflex6 = isDown;
	self.playHidraulic5 = not self.playHidraulic5;
        end;
                    if sym == Input.KEY_KP_3 then
		self.rotationMinflex7 = isDown;
	self.playHidraulic4 = not self.playHidraulic4;
         end;
	if sym == Input.KEY_KP_0 then
		self.rotationMaxflex7 = isDown;
	self.playHidraulic5 = not self.playHidraulic5;
        end;
                            if sym == Input.KEY_KP_8 then
		self.rotationMinflex12 = isDown;
	self.playHidraulic4 = not self.playHidraulic4;
         end;
	if sym == Input.KEY_KP_5 then
		self.rotationMaxflex12 = isDown;
	self.playHidraulic5 = not self.playHidraulic5;
        end;
                            if sym == Input.KEY_KP_8 then
		self.rotationMinflex13 = isDown;
	self.playHidraulic4 = not self.playHidraulic4;
         end;
	if sym == Input.KEY_KP_5 then
		self.rotationMaxflex13 = isDown;
	self.playHidraulic5 = not self.playHidraulic5;
        end;
                            if sym == Input.KEY_KP_8 then
		self.rotationMinflex14 = isDown;
	self.playHidraulic4 = not self.playHidraulic4;
         end;
	if sym == Input.KEY_KP_5 then
		self.rotationMaxflex14 = isDown;
	self.playHidraulic5 = not self.playHidraulic5;
        end;
                            if sym == Input.KEY_KP_8 then
		self.rotationMinflex15 = isDown;
	self.playHidraulic4 = not self.playHidraulic4;
         end;
	if sym == Input.KEY_KP_5 then
		self.rotationMaxflex15 = isDown;
	self.playHidraulic5 = not self.playHidraulic5;
        end;
	if sym == Input.KEY_KP_6 then
		self.rotationMaxworkingArm = isDown;
	self.playHidraulic6 = not self.playHidraulic6;
        end;
	if sym == Input.KEY_KP_9 then
		self.rotationMinworkingArm = isDown;
	 self.playHidraulic7 = not self.playHidraulic7;
        end;




  end;
  
end;
function liebherr:update(dt)



	for i, jointDesc in pairs(self.componentJoints) do
	   setJointFrame(self.componentJoints[i].jointIndex, 0, self.componentJoints[i].jointNode);
	end;
	
	
	
if self:getIsActive() and self.isClient then
    if self.isEntered and self.isMotorStarted then
       if self.playHidraulic or self.playHidraulic1 or self.playHidraulic2 or self.playHidraulic3 or self.playHidraulic4 or self.playHidraulic5 or self.playHidraulic6 or self.playHidraulic7 then
            if self.hidraulicSound ~= nil and not self.hidraulicSoundEnabled then
                if self:getIsActiveForSound() then
                    setSamplePitch(self.hidraulicSound, self.hidraulicSoundPitchOffset);
                    playSample(self.hidraulicSound, 0, 0.5, 0);
                    self.hidraulicSoundEnabled = true;
                end;
            end;
     
	
        else
            if self.hidraulicSound ~= nil and self.hidraulicSoundEnabled then
                stopSample(self.hidraulicSound);
                self.hidraulicSoundEnabled = false;
            end;
     
	end;
   end;




       





	local doRotate = self.rotationMaxtourelle or self.rotationMintourelle
    	if self.tourelle ~= nil and doRotate then
		local x, y, z = getRotation(self.tourelle.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.tourelle.maxRot, self.tourelle.minRot, 3, self.tourelle.rotTime, dt, not self.rotationMaxtourelle);
		setRotation(self.tourelle.node, unpack(newRot));		
	end;
		local doRotate = self.rotationMaxflex1 or self.rotationMinflex1
    	if self.flex1 ~= nil and doRotate then
		local x, y, z = getRotation(self.flex1.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.flex1.maxRot, self.flex1.minRot, 3, self.flex1.rotTime, dt, not self.rotationMaxflex1);
		setRotation(self.flex1.node, unpack(newRot));		
	end;
			local doRotate = self.rotationMaxflex2 or self.rotationMinflex2
    	if self.flex2 ~= nil and doRotate then
		local x, y, z = getRotation(self.flex2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.flex2.maxRot, self.flex2.minRot, 3, self.flex2.rotTime, dt, not self.rotationMaxflex2);
		setRotation(self.flex2.node, unpack(newRot));		
	end;
			local doRotate = self.rotationMaxflex3 or self.rotationMinflex3
    	if self.flex3 ~= nil and doRotate then
		local x, y, z = getRotation(self.flex3.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.flex3.maxRot, self.flex3.minRot, 3, self.flex3.rotTime, dt, not self.rotationMaxflex3);
		setRotation(self.flex3.node, unpack(newRot));		
	end;
			local doRotate = self.rotationMaxflex4 or self.rotationMinflex4
    	if self.flex4 ~= nil and doRotate then
		local x, y, z = getRotation(self.flex4.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.flex4.maxRot, self.flex4.minRot, 3, self.flex4.rotTime, dt, not self.rotationMaxflex4);
		setRotation(self.flex4.node, unpack(newRot));		
	end;
				local doRotate = self.rotationMaxflex6 or self.rotationMinflex6
    	if self.flex6 ~= nil and doRotate then
		local x, y, z = getRotation(self.flex6.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.flex6.maxRot, self.flex6.minRot, 3, self.flex6.rotTime, dt, not self.rotationMaxflex6);
		setRotation(self.flex6.node, unpack(newRot));
	end;
				local doRotate = self.rotationMaxflex7 or self.rotationMinflex7
    	if self.flex7 ~= nil and doRotate then
		local x, y, z = getRotation(self.flex7.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.flex7.maxRot, self.flex7.minRot, 3, self.flex7.rotTime, dt, not self.rotationMaxflex7);
		setRotation(self.flex7.node, unpack(newRot));
	end;
					local doRotate = self.rotationMaxflex12 or self.rotationMinflex12
    	if self.flex12 ~= nil and doRotate then
		local x, y, z = getRotation(self.flex12.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.flex12.maxRot, self.flex12.minRot, 3, self.flex12.rotTime, dt, not self.rotationMaxflex12);
		setRotation(self.flex12.node, unpack(newRot));
	end;
					local doRotate = self.rotationMaxflex13 or self.rotationMinflex13
    	if self.flex13 ~= nil and doRotate then
		local x, y, z = getRotation(self.flex13.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.flex13.maxRot, self.flex13.minRot, 3, self.flex13.rotTime, dt, not self.rotationMaxflex13);
		setRotation(self.flex13.node, unpack(newRot));
	end;
					local doRotate = self.rotationMaxflex14 or self.rotationMinflex14
    	if self.flex14 ~= nil and doRotate then
		local x, y, z = getRotation(self.flex14.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.flex14.maxRot, self.flex14.minRot, 3, self.flex14.rotTime, dt, not self.rotationMaxflex14);
		setRotation(self.flex14.node, unpack(newRot));
	end;
					local doRotate = self.rotationMaxflex15 or self.rotationMinflex15
    	if self.flex15 ~= nil and doRotate then
		local x, y, z = getRotation(self.flex15.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.flex15.maxRot, self.flex15.minRot, 3, self.flex15.rotTime, dt, not self.rotationMaxflex15);
		setRotation(self.flex15.node, unpack(newRot));
	end;
	
   
	
   	local doRotate = self.rotationMaxbras2 or self.rotationMinbras2
    	if self.bras2 ~= nil and doRotate then
		local x, y, z = getRotation(self.bras2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.bras2.maxRot, self.bras2.minRot, 3, self.bras2.rotTime, dt, not self.rotationMaxbras2);
		setRotation(self.bras2.node, unpack(newRot));
		
	end;
		   	local doRotate = self.rotationMaxbras3 or self.rotationMinbras3
    	if self.bras3 ~= nil and doRotate then
		local x, y, z = getRotation(self.bras3.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.bras3.maxRot, self.bras3.minRot, 3, self.bras3.rotTime, dt, not self.rotationMaxbras3);
		setRotation(self.bras3.node, unpack(newRot));

	end;	
   	local doRotate = self.rotationMaxbras1 or self.rotationMinbras1
    	if self.bras1 ~= nil and doRotate then
		local x, y, z = getRotation(self.bras1.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.bras1.maxRot, self.bras1.minRot, 3, self.bras1.rotTime, dt, not self.rotationMaxbras1);
		setRotation(self.bras1.node, unpack(newRot));
		
	end;
	   	local doRotate = self.rotationMaxbras4 or self.rotationMinbras4
    	if self.bras4 ~= nil and doRotate then
		local x, y, z = getRotation(self.bras4.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.bras4.maxRot, self.bras4.minRot, 3, self.bras4.rotTime, dt, not self.rotationMaxbras4);
		setRotation(self.bras4.node, unpack(newRot));

	end;
	
    local doRotate = self.rotationMaxworkingArm or self.rotationMinworkingArm
	if self.workingArm ~= nil and doRotate then
		local x, y, z = getRotation(self.workingArm.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.workingArm.maxRot, self.workingArm.minRot, 3, self.workingArm.rotTime, dt, self.rotationMaxworkingArm);
		setRotation(self.workingArm.node, unpack(newRot));
		
	end;
	
	local doRotate = self.rotationMaxworkingArm or self.rotationMinworkingArm
	if self.transformer ~= nil and doRotate then
		local x, y, z = getRotation(self.transformer.node);
	    local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.transformer.maxRot, self.transformer.minRot, 3, self.transformer.rotTime, dt, self.rotationMaxworkingArm);
		setRotation(self.transformer.node, unpack(newRot));
		
	end;


    if self.hydraulicMainArm ~= nil and self.transformer ~= nil then
		local ax, ay, az = getWorldTranslation(self.hydraulicMainArm.node);
		local bx, by, bz = getWorldTranslation(self.transformer.fixPoint);
		local x, y, z = worldDirectionToLocal(getParent(self.hydraulicMainArm.node), bx-ax, by-ay, bz-az);
		setDirection(self.hydraulicMainArm.node, x*-1, y*-1, z*-1, 0, 1, 0);
		if self.hydraulicMainArm.punch ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
		    setTranslation(self.hydraulicMainArm.punch, 0, 0, (distance-self.hydraulicMainArm.punchDistance)*-1);

		end;

	end;

	if self.transformer ~= nil and self.workingArm ~= nil then
	    local ax, ay, az = getWorldTranslation(self.transformer.transform2);
	    local bx, by, bz = getWorldTranslation(self.workingArm.fixPoint);
	    local x, y, z = worldDirectionToLocal(getParent(self.transformer.transform2), bx-ax, by-ay, bz-az);
	    setDirection(self.transformer.transform2, x*-1, y*-1, z*-1, 0, 1, 0);
	end;

    
	if self.verin2 ~= nil and self.bras2 ~= nil then
		local ax, ay, az = getWorldTranslation(self.verin2.node);
		local bx, by, bz = getWorldTranslation(self.bras2.pivotverin);
		local x, y, z = worldDirectionToLocal(getParent(self.verin2.node), bx-ax, by-ay, bz-az);
		setDirection(self.verin2.node, x*-1, y*-1, z*-1, 0, 1, 0);
		if self.verin2.tige ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.verin2.tige, 0, 0, (distance-self.verin2.tigeDistance)*-1);
		end;
	end;
		if self.verin3 ~= nil and self.bras3 ~= nil then
		local ax, ay, az = getWorldTranslation(self.verin3.node);
		local bx, by, bz = getWorldTranslation(self.bras3.pivotverin);
		local x, y, z = worldDirectionToLocal(getParent(self.verin3.node), bx-ax, by-ay, bz-az);
		setDirection(self.verin3.node, x*-1, y*-1, z*-1, 0, 1, 0);
		if self.verin3.tige ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.verin3.tige, 0, 0, (distance-self.verin3.tigeDistance)*-1);
		end;
	end;
	if self.verin1 ~= nil and self.bras1 ~= nil then
		local ax, ay, az = getWorldTranslation(self.verin1.node);
		local bx, by, bz = getWorldTranslation(self.bras1.pivotverin);
		local x, y, z = worldDirectionToLocal(getParent(self.verin1.node), bx-ax, by-ay, bz-az);
		setDirection(self.verin1.node, x*-1, y*-1, z*-1, 0, 1, 0);
		if self.verin1.tige ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.verin1.tige, 0, 0, (distance-self.verin1.tigeDistance)*-1);
		end;
	end;
		if self.flex5 ~= nil and self.bras2 ~= nil then
		local ax, ay, az = getWorldTranslation(self.flex5.node);
		local bx, by, bz = getWorldTranslation(self.bras2.pivotverin2);
		local x, y, z = worldDirectionToLocal(getParent(self.flex5.node), bx-ax, by-ay, bz-az);
		setDirection(self.flex5.node, x*-1, y*-1, z*-1, 0, 1, 0);
		if self.flex5.tige ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.flex5.tige, 0, 0, (distance-self.flex5.tigeDistance)*-1);
		end;
	end;
			if self.flex8 ~= nil and self.bras2 ~= nil then
		local ax, ay, az = getWorldTranslation(self.flex8.node);
		local bx, by, bz = getWorldTranslation(self.bras2.pivotverin3);
		local x, y, z = worldDirectionToLocal(getParent(self.flex8.node), bx-ax, by-ay, bz-az);
		setDirection(self.flex8.node, x*-1, y*-1, z*-1, 0, 1, 0);
		if self.flex8.tige ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.flex8.tige, 0, 0, (distance-self.flex8.tigeDistance)*-1);
		end;
	end;
				if self.flex9 ~= nil and self.bras3 ~= nil then
		local ax, ay, az = getWorldTranslation(self.flex9.node);
		local bx, by, bz = getWorldTranslation(self.bras3.pivotverin2);
		local x, y, z = worldDirectionToLocal(getParent(self.flex9.node), bx-ax, by-ay, bz-az);
		setDirection(self.flex9.node, x*-1, y*-1, z*-1, 0, 1, 0);
		if self.flex9.tige ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.flex9.tige, 0, 0, (distance-self.flex9.tigeDistance)*-1);
		end;
	end;
					if self.flex10 ~= nil and self.bras3 ~= nil then
		local ax, ay, az = getWorldTranslation(self.flex10.node);
		local bx, by, bz = getWorldTranslation(self.bras3.pivotverin2);
		local x, y, z = worldDirectionToLocal(getParent(self.flex10.node), bx-ax, by-ay, bz-az);
		setDirection(self.flex10.node, x*-1, y*-1, z*-1, 0, 1, 0);
		if self.flex10.tige ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.flex10.tige, 0, 0, (distance-self.flex10.tigeDistance)*-1);
		end;
	end;
						if self.flex11 ~= nil and self.bras4 ~= nil then
		local ax, ay, az = getWorldTranslation(self.flex11.node);
		local bx, by, bz = getWorldTranslation(self.bras4.pivotverin);
		local x, y, z = worldDirectionToLocal(getParent(self.flex11.node), bx-ax, by-ay, bz-az);
		setDirection(self.flex11.node, x*-1, y*-1, z*-1, 0, 1, 0);
		if self.flex11.tige ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.flex11.tige, 0, 0, (distance-self.flex11.tigeDistance)*-1);
		end;
	end;



end;	
end;
      


function liebherr:draw()
  g_currentMission:addExtraPrintText("Touche KP_1/KP_2: Rotation Tourelle");
  g_currentMission:addExtraPrintText("Touche KP_7/KP_4/KP_8/KP_5/KP_9/KP_6: Bras");   	
end;

function liebherr:onDeactivateSounds()
    if self.hidraulicSound ~= nil and self.hidraulicSoundEnabled then
        stopSample(self.hidraulicSound);
        self.hidraulicSoundEnabled = false;
    end; 
end;


function liebherr:anim(varName, loopCheck)
end;


function liebherr:connectCollisions(varName)
end;



function liebherr:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;

function liebherr:doRotate(index, boolean, dt)
end;
